From ae3248f452759228a3080916baa0fdee070ca5dd Mon Sep 17 00:00:00 2001
From: tanghy <tanghy.fnst@fujitsu.com>
Date: Fri, 6 Aug 2021 16:13:05 +0900
Subject: [PATCH] Remove obsolete macro CHECKFLOATVAL


diff --git a/contrib/btree_gist/btree_float4.c b/contrib/btree_gist/btree_float4.c
index 3604c73313..1114d3ca95 100644
--- a/contrib/btree_gist/btree_float4.c
+++ b/contrib/btree_gist/btree_float4.c
@@ -98,7 +98,8 @@ float4_dist(PG_FUNCTION_ARGS)
 	float4		r;
 
 	r = a - b;
-	CHECKFLOATVAL(r, isinf(a) || isinf(b), true);
+	if (unlikely(isinf(r)) && !isinf(a) && !isinf(b))
+		float_overflow_error();
 
 	PG_RETURN_FLOAT4(Abs(r));
 }
diff --git a/contrib/btree_gist/btree_float8.c b/contrib/btree_gist/btree_float8.c
index 10a5262aaa..e5ef193b49 100644
--- a/contrib/btree_gist/btree_float8.c
+++ b/contrib/btree_gist/btree_float8.c
@@ -76,8 +76,8 @@ gbt_float8_dist(const void *a, const void *b, FmgrInfo *flinfo)
 	float8		r;
 
 	r = arg1 - arg2;
-	CHECKFLOATVAL(r, isinf(arg1) || isinf(arg2), true);
-
+	if (unlikely(isinf(r)) && !isinf(arg1) && !isinf(arg2))
+		float_overflow_error();
 	return Abs(r);
 }
 
@@ -106,7 +106,8 @@ float8_dist(PG_FUNCTION_ARGS)
 	float8		r;
 
 	r = a - b;
-	CHECKFLOATVAL(r, isinf(a) || isinf(b), true);
+	if (unlikely(isinf(r)) && !isinf(a) && !isinf(b))
+		float_overflow_error();
 
 	PG_RETURN_FLOAT8(Abs(r));
 }
diff --git a/contrib/btree_gist/btree_utils_num.h b/contrib/btree_gist/btree_utils_num.h
index cec6986172..db7ab54304 100644
--- a/contrib/btree_gist/btree_utils_num.h
+++ b/contrib/btree_gist/btree_utils_num.h
@@ -9,6 +9,7 @@
 
 #include "access/gist.h"
 #include "btree_gist.h"
+#include "utils/float.h"
 #include "utils/rel.h"
 
 typedef char GBT_NUMKEY;
@@ -89,23 +90,6 @@ typedef struct
 
 #define GET_FLOAT_DISTANCE(t, arg1, arg2)	Abs( ((float8) *((const t *) (arg1))) - ((float8) *((const t *) (arg2))) )
 
-/*
- * check to see if a float4/8 val has underflowed or overflowed
- * borrowed from src/backend/utils/adt/float.c
- */
-#define CHECKFLOATVAL(val, inf_is_valid, zero_is_valid)			\
-do {															\
-	if (isinf(val) && !(inf_is_valid))							\
-		ereport(ERROR,											\
-				(errcode(ERRCODE_NUMERIC_VALUE_OUT_OF_RANGE),	\
-		  errmsg("value out of range: overflow")));				\
-																\
-	if ((val) == 0.0 && !(zero_is_valid))						\
-		ereport(ERROR,											\
-				(errcode(ERRCODE_NUMERIC_VALUE_OUT_OF_RANGE),	\
-		 errmsg("value out of range: underflow")));				\
-} while(0)
-
 
 extern Interval *abs_interval(Interval *a);
 
-- 
2.31.1.windows.1

